import { Request, Response, Middleware } from "./";
export interface Portal<Request, Response> {
    (request: Request): Promise<Response>;
}
/**
 * Read all response headers from the given XHR instance into a standard
 * object literal.
 */
export declare function getAllHeaders(xhr: XMLHttpRequest): object;
/**
 * Sends the request to the server.  This is used by createPortal() after
 * all middleware has been applied.
 */
export declare function send(request: Request): Promise<Response>;
/**
 * Creates and returns a new "portal" instance for creating HTTP
 * requests.  Each request and response is passed through the
 * given middleware.
 */
export declare function createPortal<Req extends Request = Request, Res extends Response = Response>(...middleware: Middleware<Req, Res>[]): Portal<Req, Res>;
